import java_cup.runtime.*;

%%

%line
%column
%cup
%class Lexer

%%

if      {return new Symbol(sym.IF, yyline, yycolumn);}
else    {return new Symbol(sym.ELSE, yyline, yycolumn);}
while   {return new Symbol(sym.WHILE, yyline, yycolumn);}
write	{return new Symbol(sym.WRITE, yyline, yycolumn);}
read	{return new Symbol(sym.READ, yyline, yycolumn);}

int 	{return new Symbol(sym.INT, yyline, yycolumn);}
true	{return new Symbol(sym.TRUE, yyline, yycolumn);}
false	{return new Symbol(sym.FALSE, yyline, yycolumn);}

[A-z_$][0-9A-z_$]*  {return new Symbol(sym.ID, yyline, yycolumn, yytext());}
-?[0-9]+  {return new Symbol(sym.NUMBER, yyline, yycolumn, yytext());}
\{      {return new Symbol(sym.LBRACE, yyline, yycolumn);}
\}      {return new Symbol(sym.RBRACE, yyline, yycolumn);}
\(		{return new Symbol(sym.LPAREN, yyline, yycolumn);}
\)		{return new Symbol(sym.RPAREN, yyline, yycolumn);}
\+      {return new Symbol(sym.PLUS, yyline, yycolumn);}
\-      {return new Symbol(sym.MINUS, yyline, yycolumn);}
\*      {return new Symbol(sym.TIMES, yyline, yycolumn);}
\/      {return new Symbol(sym.DIVIDE, yyline, yycolumn);}
\% 		{return new Symbol(sym.MOD, yyline, yycolumn);}

;       {return new Symbol(sym.SEMICOLON, yyline, yycolumn);}
,		{return new Symbol(sym.COMMA, yyline, yycolumn);}
=       {return new Symbol(sym.ASSIGN, yyline, yycolumn);}
\!		{return new Symbol(sym.NOT, yyline, yycolumn);}
== 		{return new Symbol(sym.EQUAL, yyline, yycolumn);}
\!= 	{return new Symbol(sym.NOT_EQUAL, yyline, yycolumn);}
\<		{return new Symbol(sym.LESS, yyline, yycolumn);}
\<= 	{return new Symbol(sym.LESS_EQUAL, yyline, yycolumn);}
>		{return new Symbol(sym.GREATER, yyline, yycolumn);}
>= 		{return new Symbol(sym.GREATER_EQUAL, yyline, yycolumn);}
&& 		{return new Symbol(sym.ANDAND, yyline, yycolumn);}
\|\|	{return new Symbol(sym.OROR, yyline, yycolumn);}

.|\n    {}


